#include <iostream>
#include <string>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <vector>

using namespace std;
typedef long long LL;

#define sz(x) (int)(x).size()
#define rep(i,a,b) for(int i=a; i<(b); i++)
typedef vector<int> vi;

array<vi, 2> manacher(const string& s) {
	int n = sz(s);
	array<vi, 2> p = {vi(n+1), vi(n)};
	rep(z, 0, 2) for (int i = 0,l=0,r=0; i < n; i++){
		int t = r-i+!z;
		if (i<r) p[z][i] = min(t, p[z][l+t]);
		int L = i-p[z][i], R = i+p[z][i]-!z;
		while (L>=1 && R+1<n && s[L-1] == s[R+1]){
			p[z][i]++, L--, R++;
		}
		if (R>r) l=L, r=R;
	}
	return p;
	
}

int main() {
	int n;
	string s;
	scanf("%d", &n);
	cin>>s;
	
	auto res = manacher(s);
	
	//for (int i = 0; i < n; i++){
	//	cout << res[0][i] << " " << res[1][i]<<endl;
	//}
	
	int mxpal = 1;
	for (int i = 0; i < n; i++){
		if (i+res[0][i] == n) {
			//printf("%d\n", i);
			mxpal = max(mxpal, 2*res[0][i]);
		}
	}
	//printf("---------\n");
	for (int i = 0; i < n; i++){
		if (i+res[1][i]+1 == n) {
			mxpal = max(mxpal, 2*res[1][i]+1);
			//printf("%d\n", i);
		 }
	}
	//printf("---------\n");
	//printf("%d\n", mxpal);
	printf("%d\n", n-mxpal);
	
	
	
	return 0;
}

